﻿Type=Service
Version=7
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: true
#End Region


'Service module
Sub Process_Globals
	Type msg (Address As String, Body As String)
	Dim SQL1 As SQL
End Sub

Sub Service_Create

End Sub

Sub Service_Destroy

End Sub

Sub Service_Start(startingIntent As Intent)
	If startingIntent.Action = "android.provider.Telephony.SMS_RECEIVED" Then
		Dim messages() As msg
		messages = ParseSmsIntent(startingIntent)
		For i = 0 To messages.Length - 1
			Log(messages(i))
		Next
	End If
End Sub

'Parses an SMS intent and returns an array of messages
Sub ParseSmsIntent (in As Intent) As msg()
	Dim messages() As msg
	If in.HasExtra("pdus") = False Then Return messages
	Dim pdus() As Object
	Dim r As Reflector
	pdus = in.GetExtra("pdus")
	If pdus.Length > 0 Then
		Dim messages(pdus.Length) As msg
		For i = 0 To pdus.Length - 1
			r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
			messages(i).Body = r.RunMethod("getMessageBody")
			messages(i).Address = r.RunMethod("getOriginatingAddress")
		Next
	End If
	Return messages
End Sub


